SystemOrganization addCategory: #'EsAndEm-Tests'!
SystemOrganization addCategory: #'EsAndEM-Core'!

!CompiledMethod methodsFor: '*esandem-dispatch' stamp: 'cwp 8/25/2010 11:13'!
serializeWith: aSerializer
	aSerializer serializeReferenceTo: self! !

!Boolean methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 19:37'!
serializeWith: aMarshal
	aMarshal serializeSingleton: self! !

!Integer methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 16:09'!
serializeWith: aSerializer
	aSerializer serializeInteger: self! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 7/12/2010 21:42'!
closure: aBlockClosure
	closureOrNil := aBlockClosure! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 9/8/2008 07:44'!
serializeWith: aSerializer
	^ aSerializer serializeMethodContext: self! !

!Float methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 19:51'!
serializeWith: aSerializer
	^ aSerializer serializeFloat: self! !

!Dictionary methodsFor: '*esandem-dispatch' stamp: 'cwp 9/2/2008 22:26'!
serializeWith: aSerializer
	^ aSerializer serializeDictionary: self! !

!Symbol methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 00:04'!
serializeWith: aSerializer
	aSerializer serializeSymbol: self! !

TestCase subclass: #SMSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/2/2008 00:30'!
assertEqualityOf: expected
	^ self 
		assertEquivalenceOf: expected 
		with: [:actual | actual = expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/5/2008 07:55'!
assertEquivalenceOf: expected with: aBlock
	self 
		examineResultOf: expected 
		with: 
			[:actual | 
			self assert: (aBlock value: actual)]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 8/31/2008 23:00'!
assertIdentityOf: expected
	^ self
		assertEquivalenceOf: expected
		with: [:actual | actual == expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/23/2008 21:03'!
createSubcontinuation
	| subcontinuation |
	subcontinuation := ALSubcomputation do: 
		[ : p | 
		self 
			doSubcomp: 3
			with: [ p escape: [ : k | k ] ] ].
	^ subcontinuation! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/19/2008 08:01'!
doSubcomp: anInteger with: aBlock
	^ anInteger = 0
		ifTrue: aBlock
		ifFalse: [(self doSubcomp: anInteger - 1 with: aBlock) + 1]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/8/2008 21:17'!
examineResultOf: expected with: aBlock
	| actual archive |
	archive := expected serialize.
	actual := archive materialize.
	aBlock value: actual! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 19:13'!
testArchive
	| archive |
	archive := 3 serialize.
	self assert: archive materialize = 3! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 20:43'!
testArray
	self assertEqualityOf: #(1 'two' 3.0)! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:24'!
testByte
	self assertEqualityOf: 42! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 07:09'!
testBytesObject
	self assertEqualityOf: UUID new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 23:02'!
testClass
	self assertIdentityOf: self class! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:08'!
testCompiledMethod
	self assertIdentityOf: thisContext method.
	! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:57'!
testCyclicalReferenceArray
	| object |
	object := Array new: 1.
	object at: 1 put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual first == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:06'!
testCyclicalReferenceDictionary
	| object |
	object := Dictionary new: 1.
	object at: #one put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | (actual at: #one) == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:16'!
testCyclicalReferenceObject
	| object |
	object := ValueHolder new.
	object contents: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual contents == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:58'!
testCyclicalReferenceSet
	| object |
	object := Set new: 1.
	object add: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual anyOne == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:22'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3;
		yourself.
	self assertEqualityOf: dict! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 21:33'!
testDigest
	| archive |
	archive := 3 serialize.
	self assert: archive digest = 'df2b71f6eb25b9768ff32a8105911d193a350eb8'! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/18/2010 12:34'!
testExternalObject
	| object |
	object := SMObjectWithExternalState new.
	self 
		assertEquivalenceOf: object
		with: 
			[:actual |
			actual alpha ~~ object alpha
				and: [actual beta == object beta]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testFalse
	self assertIdentityOf: false! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:50'!
testFloat
	self assertEqualityOf: 3.4! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargeNegativeInteger
	self assertEqualityOf: -65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargePositiveInteger
	self assertEqualityOf: 65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:15'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:59'!
testMultiString
	| ws |
	ws := WideString fromString: 'abc'.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testNil
	self assertIdentityOf: nil! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 01:13'!
testObject
	self 
		assertEquivalenceOf: self 
		with: 
			[:actual |
			actual class = self class
				and: [actual selector = self selector]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/13/2008 00:21'!
testOrderedCollection
	self assertEqualityOf: OrderedCollection new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:06'!
testSet
	self assertEqualityOf: #(1 'two' 3.0) asSet! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallNegativeInteger
	self assertEqualityOf: -300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallPositiveInteger
	self assertEqualityOf: 300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testString
	self assertEqualityOf: 'abc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 00:04'!
testSymbol
	self assertIdentityOf: #one! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:26'!
testTrue
	self assertIdentityOf: true! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 7/14/2010 11:04'!
testVariablePointerObject
	| expected |
	expected := (SparseLargeTable new: 3)
		at: 1 put: $a;
		at: 2 put: $b;
		at: 3 put: $c;
		yourself.

	self 
		assertEquivalenceOf: expected 
		with: 
			[:actual |
			actual class = expected class
				and: [actual = expected]]! !

!Object methodsFor: '*esandem-serializing' stamp: 'cwp 8/23/2010 22:32'!
serialize
	^ SMArchive with: self! !

!Object methodsFor: '*esandem-serializing' stamp: 'cwp 9/2/2008 00:35'!
serializeWith: aSerializer
	aSerializer serializeObject: self! !

Object subclass: #SMArchive
	instanceVariableNames: 'bytes references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArchive class methodsFor: 'instance creation' stamp: 'cwp 8/25/2010 11:31'!
bytes: aByteArray references: anArray
	^ self new setBytes: aByteArray references: anArray! !

!SMArchive class methodsFor: 'serializing' stamp: 'cwp 8/25/2010 11:31'!
with: anObject
	| ext stream |
	stream := (ByteArray new: 100) writeStream.
	ext := SMSerializer serialize: anObject on: stream.
	^ self bytes: stream contents references: ext! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 11/4/2008 00:04'!
base64
	^ (Base64MimeConverter mimeEncode: self bytes readStream) contents! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2008 23:57'!
bytes
	^ bytes! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:32'!
digest
	| sha |
	sha := SecureHashAlgorithm new.
	^ (sha hashMessage: bytes) printStringHex asLowercase! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 11:30'!
materialize
	^ (SMMaterializer on: bytes readStream)
		references: references;
		materialize! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 11:31'!
references
	^ references! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 11:31'!
setBytes: aByteArray references: anArray
	bytes := aByteArray.
	references := anArray! !

Object subclass: #SMMaterializer
	instanceVariableNames: 'decoder objects references'
	classVariableNames: 'Types'
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 9/1/2008 19:39'!
initialize
	self initializeTypes! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:59'!
initializeTypes
	Types := #(
		materializeByte
		materializeArrow
		materializeReference
		materializeClass
		materializeClass
		materializeClass
		materializeSingleton
		materializeObject
		materializeUtf8String
		materializeUtf16String
		materializeSymbol
		materializeLargeNegativeInteger
		materializeSmallNegativeInteger
		materializeSmallPositiveInteger
		materializeLargePositiveInteger
		materializeFloat
		materializeByteArray
		materializeArray
		materializeSet
		materializeDictionary
		materializeMethodContext
	)! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:57'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:56'!
on: aReadStream
	^ self new setStream: aReadStream! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 8/25/2010 11:37'!
addArrow: anObject
	objects add: anObject! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 9/1/2008 20:02'!
materialize
	| type selector |
	type := decoder getType.
	selector := Types 
		at: type
		ifAbsent: [ self error: 'unrecognized type' ].
	^ self perform: selector! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeArray
	| size array |
	size := self materialize.
	array := Array new: size.
	self addArrow: array.
	1 
		to: size
		do: 
			[ : i | 
			array 
				at: i
				put: self materialize ].
	^ array! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 11:37'!
materializeArrow
	^ objects at: self materialize! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:54'!
materializeByte
	^ decoder getByte! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeClass
	| name class |
	name := self materialize.
	class := Smalltalk at: name.
	self addArrow: class.

	"consume the inst var names"
	self materialize timesRepeat: [ self materialize ].
	^ class! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeDictionary
	| size dictionary |
	size := self materialize.
	dictionary := Dictionary new: size.
	self addArrow: dictionary.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:59'!
materializeFloat
	^ decoder getFloat! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargeNegativeInteger
	| size |
	size := self materialize.
	^ (decoder getIntegerOfSize: size) negated! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargePositiveInteger
	| size |
	size := self materialize.
	^ decoder getIntegerOfSize: size! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeMethodContext
	| method sender pc stackp closure receiver context |
	context := Object new.
	self addArrow: context.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	closure := self materialize.
	receiver := self materialize.
	context become: (MethodContext newForMethod: method).
	context
		setSender: sender
			receiver: receiver
			method: method
			arguments: #() ;
		pc: pc ;
		stackp: stackp ;
		closure: closure.
	self readPointersInto: context.
	^ context! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeObject
	| theClass object tmp |
	object := Object new.
	self addArrow: object.
	theClass := self materialize.
	tmp := theClass isVariable 
		ifTrue: [ theClass new: self materialize ]
		ifFalse: [ theClass basicNew ].
	object become: tmp.
	1 to: object class instSize do: 
		[ : i | object instVarAt: i put: self materialize ].
	object class isVariable ifTrue: 
		[ object class isPointers 
			ifTrue: [ self readPointersInto: object ]
			ifFalse: [ decoder getBytesInto: object ] ].
	^ object! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:59'!
materializeReference
	| index |
	index := self materialize.
	^ references at: index! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/25/2010 10:58'!
materializeSet
	| size set |
	size := self materialize.
	set := Set new: size.
	self addArrow: set.
	size timesRepeat: [ set add: self materialize ].
	^ set! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:55'!
materializeSingleton
	^ decoder getSingleton! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:57'!
materializeSmallNegativeInteger
	^ decoder getSmallInteger negated! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:58'!
materializeSmallPositiveInteger
	^ decoder getSmallInteger! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:35'!
materializeSymbol
	^ self materializeUtf8String asSymbol! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:42'!
materializeUtf16String
	| size |
	size := self materialize.
	^ decoder getUtf16StringOfSize: size.
	! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:41'!
materializeUtf8String
	| size |
	size := self materialize.
	^ decoder getUtf8StringOfSize: size.
	! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 9/3/2008 19:43'!
readPointersInto: anObject 
	
	1	to: anObject size
		do:	[ :i | anObject at: i put: self materialize ]! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 8/25/2010 11:00'!
references: anArray 
	
	references := anArray! !

!SMMaterializer methodsFor: 'initialize-release' stamp: 'cwp 8/25/2010 11:37'!
setStream: aStream 
	decoder := SMObjectDecoder on: aStream.
	objects := OrderedCollection new.
! !

Object subclass: #SMObjectDecoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMObjectDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 9/2/2008 07:38'!
on: aReadStream
	^ self new setStream: aReadStream! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:50'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream next ]! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream next].
	^ value! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:46'!
getSmallInteger
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) + lo! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:45'!
getType
	^ stream next! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:39'!
readTwoBytes
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) bitOr: lo! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 9/9/2008 08:00'!
readUtf8Character
	| value |
	value := stream next.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream next bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream next bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream next bitAnd: 63)].
			^ Unicode value: value ]! !

!SMObjectDecoder methodsFor: 'initialize-release' stamp: 'cwp 9/2/2008 07:38'!
setStream: aReadStream 
	stream := aReadStream.
! !

Object subclass: #SMObjectEncoder
	instanceVariableNames: 'serializer stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMObjectEncoder class
	instanceVariableNames: 'stream'!

SMObjectEncoder class
	instanceVariableNames: 'stream'!

!SMObjectEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 16:25'!
serializer: aSerializer stream: aStream
	^ self basicNew
		initializeWithSerializer: aSerializer stream: aStream;
		yourself! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeArray: anArray
	self writeType: 18.
	self serializer serialize: anArray size! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeArrow: anInteger
	self writeType: 2.
	self serializer serialize: anInteger! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:04'!
encodeBytesFrom: anObject
	1 
		to: anObject byteSize 
		do: [:index | stream nextPut: (anObject byteAt: index)]! !

!SMObjectEncoder methodsFor: 'types' stamp: 'cwp 8/25/2010 17:17'!
encodeClass: aClass
	| type |
	"4 - named inst vars only"
	"5 - named + indexed object references"
	"6 - bytes or words" 
	type := aClass isVariable
		ifFalse: [ 4 ]		
		ifTrue:  
			[aClass isPointers
				ifTrue: [ 5 ]	
				ifFalse: [ 6 ]	 ].		
	self writeType: type.
	self serializer serialize: aClass name! !

!SMObjectEncoder methodsFor: 'types' stamp: 'cwp 8/25/2010 17:17'!
encodeContext: aContext
	self writeType: 22.
	self serializer serialize: aContext method! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeDictionary: aDictionary
	self writeType: 20.
	self serializer serialize: aDictionary size! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeFloat: aFloat
	self writeType: 16.
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2)! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 16:42'!
encodeInteger: anInteger
	anInteger < -65535
		ifTrue: [ 
			self writeLargeInteger: anInteger negated type: 12.
			^ self ].
	anInteger < 0
		ifTrue: [ 
			self writeSmallNegativeInteger: anInteger.
			^ self ].
	anInteger < 256
		ifTrue: [ 
			self writeByte: anInteger.
			^ self ].
	anInteger < 65535
		ifTrue: [ 
			self writeSmallPositiveInteger: anInteger.
			^ self ].
	self writeLargeInteger: anInteger type: 15! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeObject: anObject
	self writeType: 8.
	self serializer serialize: anObject class.
	anObject class isVariable
		ifTrue: [ self serializer serialize: anObject size ]! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeReference: index
	self writeType: 3.
	self serializer serialize: index! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeSet: aSet
	self writeType: 19.
	self serializer serialize: aSet size! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeSingleton: aBoolean
	| index |
	self writeType: 7.
	index := #(nil true false) indexOf: aBoolean.
	stream nextPut: index! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeSymbol: aSymbol
	self writeType: 11.
	self serializer serialize: aSymbol size.
	self writeUtf8String: aSymbol! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeUtf16String: aString
	self writeType: 10.
	self serializer serialize: aString size.
	self writeUtf16String: aString! !

!SMObjectEncoder methodsFor: 'encoding' stamp: 'cwp 8/25/2010 17:17'!
encodeUtf8String: aString
	self writeType: 9.
	self serializer serialize: aString size.
	self writeUtf8String: aString! !

!SMObjectEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/25/2010 16:25'!
initializeWithSerializer: aSerializer stream: aStream
	serializer := aSerializer.
	stream := aStream! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 16:30'!
serializer
	^ serializer! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 20:18'!
write32BitInteger: anInteger
	stream		
		nextPut: (anInteger bitShift: -24);
		nextPut: ((anInteger bitShift: -16) bitAnd: 255);
		nextPut: ((anInteger bitShift: -8) bitAnd: 255);
		nextPut: (anInteger bitAnd: 255)! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:17'!
writeByte: anInteger
	self writeType: 1.
	stream nextPut: anInteger! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:28'!
writeFourByteCode: anInteger
	| value |
	value := 16r10000 - anInteger.
	stream nextPut: ((value bitShift: -18) bitOr: 16rD8).
	stream nextPut: ((value bitShift: -10) bitAnd: 16rFF).
	stream nextPut: ((value bitShift: -8) bitOr: 16rDC).
	stream nextPut: (value bitAnd: 16rFF).
	

! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:17'!
writeLargeInteger: anInteger type: type
	| size byte |
	self writeType: type.
	size := (anInteger log: 256) floor + 1.
	self serializer serialize: size.
	(size - 1 to: 0 by: -1)
		do: [ :index | 
			byte := (anInteger bitShift: index * -8) bitAnd: 255.
			stream nextPut: byte ]! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeSmallInteger: anInteger
	stream nextPut: (anInteger bitShift: -8).
	stream nextPut: (anInteger bitAnd: 255). ! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:17'!
writeSmallNegativeInteger: anInteger
	self writeType: 13.
	self writeSmallInteger: anInteger abs! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:17'!
writeSmallPositiveInteger: anInteger
	self writeType: 14.
	self writeSmallInteger: anInteger! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:27'!
writeTwoByteCode: value
	stream nextPut: (value bitShift: -8).
	stream nextPut: (value bitAnd: 16rFF).! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:17'!
writeType: aByte
	stream nextPut: aByte! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:07'!
writeUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:23'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream nextPut: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream nextPut: ((value bitShift: -6) bitOr: 16rC0).
					stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream nextPut: ((value bitShift: -12) bitOr: 16rE0).
							stream nextPut: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

Object subclass: #SMObjectWithExternalState
	instanceVariableNames: 'alpha beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
alpha
	^ alpha! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
beta
	^ beta! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:39'!
initialize
	alpha := ValueHolder new
		contents: #alpha;
		yourself.
	
	beta := SMReference new
		value: #beta;
		yourself! !

Object subclass: #SMReference
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMReference class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:40'!
to: anObject
	^ self new
		value: anObject;
		yourself! !

!SMReference methodsFor: 'serialization' stamp: 'cwp 8/25/2010 11:14'!
serializeWith: aSerializer
	^ aSerializer serializeReferenceTo: self! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:38'!
value
	^ value! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:40'!
value: anObject
	^ value := anObject! !

Object subclass: #SMSerializer
	instanceVariableNames: 'encoder objects references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/31/2008 15:47'!
on: aWriteStream
	^ self new setStream: aWriteStream! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/23/2010 12:17'!
serialize: anObject
	| ext stream |
	stream := (ByteArray new: 100) writeStream.
	ext := SMSerializer serialize: anObject on: stream.
	ext isEmpty ifFalse: [self error: 'This object refers to unserializable objects'].
	^ stream contents! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/25/2010 11:10'!
serialize: anObject on: aWriteStream
	^ self 
		serialize: anObject 
		references: IdentityDictionary new 
		on: aWriteStream! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/25/2010 11:31'!
serialize: anObject references: aDictionary
	| stream external |
	stream := (ByteArray new: 100) writeStream.
	external := self serialize: anObject references: aDictionary on: stream.
	^ SMArchive bytes: stream contents references: external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/25/2010 11:10'!
serialize: anObject references: aDictionary on: aWriteStream
	^ (self on: aWriteStream)
		references: aDictionary;
		serialize: anObject;
		references! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/25/2010 16:55'!
indexOf: anObject in: anIndex do: aBlock
	^ self indexOf: anObject in: anIndex ifPresent: aBlock ifAbsent: aBlock! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
indexOf: anObject in: anIndex ifPresent: pBlock ifAbsent: aBlock
	| id |
	(anIndex includesKey: anObject)
		ifTrue: 
			[id := anIndex at: anObject.
			pBlock value: id]
		ifFalse:
			[id := anIndex size + 1.
			anIndex at: anObject put: id.
			aBlock value: id].
	
		! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/25/2010 10:53'!
references
	| array |
	array := Array new: references size.
	references keysAndValuesDo:
		[:object :i | array at: i put: object].
	^ array! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/25/2010 10:53'!
references: aDictionary
	references := aDictionary! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/31/2008 21:21'!
serialize: anObject
	anObject serializeWith: self! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/25/2010 16:35'!
serialize: anObject with: aBlock
	self
		indexOf: anObject
		in: objects
		ifPresent: [ :id | encoder encodeArrow: id ]
		ifAbsent: [ :id | aBlock value ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:31'!
serializeArray: anArray
	self serialize: anArray with: 
		[encoder encodeArray: anArray.
		anArray do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 17:13'!
serializeClass: aClass
	| vars |
	self serialize: aClass with: 
		[encoder encodeClass: aClass.
		vars := aClass allInstVarNames.
		self serialize: vars size.
		vars do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:45'!
serializeDictionary: aDictionary
	self serialize: aDictionary with: 
		[encoder encodeDictionary: aDictionary.
		aDictionary keys asArray sort do: 
			[ :key | 
			self serialize: key.
			self serialize: (aDictionary at: key) ] ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:46'!
serializeFloat: aFloat
	encoder encodeFloat: aFloat! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:42'!
serializeInteger: anInteger
	encoder encodeInteger: anInteger! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 17:16'!
serializeMethodContext: aContext
	self serialize: aContext with: 
		[encoder encodeContext: aContext.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext stackPtr.
		self serialize: aContext closure.
		self serialize: aContext receiver.
		self writePointersFrom: aContext ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 17:04'!
serializeObject: anObject
	self serialize: anObject with: 
		[encoder encodeObject: anObject.
		1 to: anObject class instSize do: [ :i | self serialize: (anObject instVarAt: i) ].
		anObject class isVariable ifTrue: 
			[anObject class isPointers
				ifTrue: [ self writePointersFrom: anObject ]
				ifFalse: [ encoder encodeBytesFrom: anObject ] ] ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:56'!
serializeReferenceTo: anObject

	self
		indexOf: anObject
		in: references
		do: [:index | encoder encodeReference: index]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:57'!
serializeSet: aSet
	self serialize: aSet with: 
		[encoder encodeSet: aSet.
		aSet do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:57'!
serializeSingleton: aBoolean
	encoder encodeSingleton: aBoolean! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:58'!
serializeSymbol: aSymbol
	encoder encodeSymbol: aSymbol! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 17:00'!
serializeUtf16String: aString
	encoder encodeUtf16String: aString! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/25/2010 16:59'!
serializeUtf8String: aString
	encoder encodeUtf8String: aString! !

!SMSerializer methodsFor: 'initialize-release' stamp: 'cwp 8/25/2010 16:26'!
setStream: aWriteStream 
	encoder := SMObjectEncoder serializer: self stream: aWriteStream.
	objects := IdentityDictionary new.
	references := IdentityDictionary new.
! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/25/2010 11:18'!
writePointersFrom: anObject
	1 to: anObject size do: [ :i | self serialize: (anObject at: i)]! !

!WideString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf16String: self! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 23:04'!
serializeWith: aSerializer
	aSerializer serializeClass: self! !

!ByteString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf8String: self! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 9/2/2008 00:25'!
serializeWith: aSerializer
	aSerializer serializeArray: self! !

!UndefinedObject methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 19:36'!
serializeWith: aSerializer
	^ aSerializer serializeSingleton: self! !
SMMaterializer initialize!
